<?php

class actionRim5helperReport extends cmsAction {

    public function run($type, $id, $ctype_name){
        
        if (!cmsUser::isLogged()) { cmsCore::error404(); }
        
        if (!$type || !$id || !$ctype_name){            
            cmsUser::addSessionMessage(LANG_RIM5HELPER_REPORT_ERROR, 'error');
            $this->redirectBack();                        
        }        
        
        $messenger = cmsCore::getController('messages');
        //Всегда администратор
        $messenger->clearRecipients()->addRecipient(1);
        
        $user = cmsUser::getInstance();
        $user_url = href_to_abs('users', $user->id);
        
        $form = new cmsForm();
        $fieldset_id = $form->addFieldset('');
        
        $items = array(                    
                    '_insults' => LANG_RIM5HELPER_REPORT_TYPE_INSULTS,
                    '_spam' => LANG_RIM5HELPER_REPORT_TYPE_SPAM,
                    '_violents' => LANG_RIM5HELPER_REPORT_TYPE_VIOLENTS,
                    '_porn' => LANG_RIM5HELPER_REPORT_TYPE_PORN,
                    '_own' => LANG_RIM5HELPER_REPORT_TYPE_OWN,
                );
        
        $form->addField($fieldset_id,
            new fieldList('reason', array(
                'title' => LANG_RIM5HELPER_REPORT_REASON,
                'generator' => function() use ($items) {
                    return $items;
                }
            ))
        );        
        
        $form->addField($fieldset_id,
            new fieldText('message', array(
                'title' => LANG_RIM5HELPER_REPORT_MESSAGE
            ))
        );        

        $is_submitted = $this->request->has('message');
        $data = $form->parse($this->request, $is_submitted);        
        
        if ($is_submitted){
            
            if($type == 'content') {        
                
                $model = cmsCore::getModel('content');
                $item = $model->getContentItem($ctype_name, $id);
                $page_url = href_to_abs($ctype_name, $item['slug'] . '.html');
                
                $keys = array(
                    'user_url' => $user_url,
                    'user_nickname' => $user->nickname,
                    'page_url' => $page_url,
                    'item_title' => $item['title'],
                    'reason' => $items[$data['reason']],
                    'message' => $data['message']
                );
                
                $notice = array(                
                    'content' => string_replace_keys_values(LANG_RIM5HELPER_REPORT_CONTENT, $keys),
                    'actions' => array(
                        'view' => array(
                            'title' => LANG_SHOW,
                            'href' => $page_url
                        )
                    )
                );
                $messenger->sendNoticePM($notice);            
            }
            else if($type == 'user') {                                                
                
                $model = cmsCore::getModel('users');
                $author = $model->getUser($id);
                $page_url = href_to_abs('users', $id);
                
                $keys = array(
                    'user_url' => $user_url,
                    'user_nickname' => $user->nickname,
                    'page_url' => $page_url,
                    'author_nickname' => $author['nickname'],
                    'reason' => $items[$data['reason']],
                    'message' => $data['message']
                );                

                $notice = array(                
                    'content' => string_replace_keys_values(LANG_RIM5HELPER_REPORT_USER, $keys),
                    'actions' => array(
                        'view' => array(
                            'title' => LANG_SHOW,
                            'href' => $page_url
                        )
                    )
                );    
                $messenger->sendNoticePM($notice);            
            } 
            
            cmsUser::addSessionMessage(LANG_RIM5HELPER_REPORT_SUCCESS, 'success');
            $this->redirectBack();  
        }        
        
        return $this->cms_template->render('form', array(
            'form' => $form,
            'type'   => $type,
            'id' => $id,
            'ctype_name' => $ctype_name
        ));             
    }

}
